--
--tithe 1.0 By: Mad Miner Moda
--
--       n 1: a levy of one tenth of something.
--         2: an offering of a tenth part of some personal income.
--         v 1: exact a tithe from; "The church was tithed"
--         2: levy a tithe on (produce or a crop); "The wool was thithed"
--         3: pay one tenth of; pay tithes on, especially to the church;
--            "He tithed his income to the Church"
--         4: pay a tenth of one's income, especially to the church;
--            "Although she left the church officially, she still tithes"
--
-- 1) user can enable/disable this plugin.
-- 2) user can set % to donate to the guild banking system.
-- 3) when items are sold, % of the profit deposited into the guild bank.
-- 4) baseline level is if your credits is under this amount it will not tithe
--
-- /guild deposit <amount> <reason>
--

-- Declare section
if not TITHE then
  declare (TITHE)
end
TITHE = TITHE or {}
-- end Declare


--variables
    -- for strings
TITHE.catcher = {}
TITHE.GREEN =  '\127008800'  -- green text
TITHE.RED = '\127FF0000'     -- red text
TITHE.NORMAL = '\127FFFFFF'  -- normal text
TITHE.VERSION = "3.0"

    -- percent to tithe, default is 10%
TITHE.percent = gkini.ReadString('TITHE','percent','10') 
TITHE.baseline = gkini.ReadString('TITHE','baseline','2000000') 
TITHE.donated = gkini.ReadString('TITHE','donated','0') 
TITHE.ENABLE = gkini.ReadString('TITHE','enabled','true')
TITHE.string = gkini.ReadString('TITHE','string',"Tithe: ") 
TITHE.least = gkini.ReadString('TITHE','least','50000')
--end variables


-- processes <string> and checks for '(profit of Nc)
function TITHE.ProcessProfit(pointer)
  local DONATION = 0
  local ITEM = ""
  if string.match(pointer,'profit of ') then
    local foo1 = string.gsub(pointer,'.*profit of ','')
    local foo2 = foo1:gsub('c.+',''):gsub(',',''):gsub(' ','')
	local PRETEST = math.floor(foo2*(TITHE.percent/100))
    if foo2 ~= nil and PRETEST ~= nil and (GetMoney() > tonumber(TITHE.baseline)) and (PRETEST > tonumber(TITHE.least)) then
			DONATION = math.floor(foo2*(TITHE.percent/100))
			foo1 = string.gsub(pointer,' sold for a total amount of.*','')
			ITEM = string.gsub(foo1,'msg="','')
			local depo_msg = 'guild deposit '..DONATION..' "'..TITHE.string..' '..ITEM..'"'
			gkinterface.GKProcessCommand(depo_msg)
			TITHE.donated = TITHE.donated + DONATION
			gkini.WriteString('TITHE','donated',TITHE.donated)
    end -- end TITHE.baseline check
  end -- end 'profit of ' check
end -- end TITHE.ProcessProfit()


-- returns xxx,xxx,xxx number format from a given xxxxxxxxxx number
function TITHE.comma_value(amount)
  if amount then 
    local substrings = {}
    local rest = amount 
    local result

    while string.len(rest) > 2 do
      local restlen = string.len(rest)
      table.insert(substrings, 1, string.sub(rest, restlen-2))
      rest = string.sub(rest, 1, restlen-3)
    end

    if string.len(rest) > 0 then table.insert(substrings, 1, rest) end
    for i,v in ipairs(substrings) do
     result = result and (result..","..v) or v
    end
    return result
  end
end -- TITHE.comma_value()


-- event hanlders
TITHE.handleevents = {}
function TITHE.handleevents:OnEvent ( eventname, ... )
  local args = { ... }
  if eventname == 'CHAT_MSG_CONFIRMATION' then
    if TITHE.ENABLE then
      TITHE.ProcessProfit(spickle(args[1])) -- check for profit made
    end
  end -- end if eventname
end -- end TITHE.handleevents()


-- /tithe foo commands here
function TITHE.commands(data, args)
  if args then
    if string.lower(args[1]) == 'percent' and tonumber(args[2]) ~= nil then  -- set the percentage
      TITHE.ChangePercent(args[2]) 
    elseif string.lower(args[1]) == 'off' then -- disable tithe
      TITHE.ENABLE = false 
      print (TITHE.GREEN.."TITHE:"..TITHE.RED.." disabled"..TITHE.NORMAL)
      gkini.WriteString('TITHE','enabled','false')
    elseif string.lower(args[1]) == 'on' then  -- enable tithe 
      TITHE.ENABLE = true   
      print (TITHE.GREEN.."TITHE:"..TITHE.RED.." enabled"..TITHE.NORMAL)
      gkini.WriteString('TITHE','enabled','true') 
    elseif args[1] == 'baseline' and tonumber(args[2]) ~= nil then -- baseline amount
      TITHE.baseline = tonumber(args[2])
      gkini.WriteString('TITHE','baseline',TITHE.baseline) 
      print (TITHE.GREEN.."TITHE: Setting baseline to "..TITHE.RED..
             TITHE.comma_value(TITHE.baseline)..TITHE.GREEN.."  Credits.")
	elseif args[1] == 'minimum' and tonumber(args[2]) ~= nil then --minumum amount
	  TITHE.least = tonumber(args[2])
	  gkini.WriteString('TITHE','least',TITHE.least)
	  print (TITHE.GREEN.."TITHE: Setting least amount to "..TITHE.RED..
			 TITHE.comma_value(TITHE.least)..TITHE.GREEN.." Credits.")
    elseif args[1] == 'stats' then -- show the stats
      TITHE.PrintStats()
    elseif args[1] == '?' then -- show help screen
      TITHE.ShowHelp()
    elseif args[1] == 'string' then -- set the tithe string msg
      TITHE.string = args[2]
      gkini.WriteString('TITHE','string',args[2])
    else -- all else is invalid
      print (TITHE.GREEN.."TITHE:"..TITHE.RED.." invalid argument, try ?."..TITHE.NORMAL)
    end
  else -- just /tithe by itself
    TITHE.ShowHelp()
  end
end -- end TITHE.commands()


-- prints usage stats 
function TITHE.PrintStats()
  print (TITHE.percent.."% is donated to the guild bank.")
  print (TITHE.string.."msg for the guild bank.")
  print (TITHE.comma_value(TITHE.baseline).."  credits is the min amount you need to tithe.")
  print (TITHE.comma_value(TITHE.donated).." is how much you have donated to date.")
  print (TITHE.comma_value(TITHE.least).." is the minimum amount to donate via Tithe.")
  if TITHE.ENABLE then 
    print ("Currently Tithe is: Enabled")
  else
    print ("Currently Tithe is: Disabled")
  end
end -- end TITHE.PrintStats()


-- changes the tithe percentage, writes to config.ini file
function TITHE.ChangePercent(newpercent)
  if tonumber(newpercent) <= 100 and tonumber(newpercent) > 0 then 
    TITHE.percent = tonumber(newpercent)
    gkini.WriteString('TITHE','percent',TITHE.percent) 
    print (TITHE.GREEN.."TITHE: Setting percent to: "..TITHE.NORMAL..TITHE.percent..'%')
  else
    print (TITHE.GREEN..":TITHE: "..TITHE.RED.." invalid percentage."..TITHE.NORMAL)
  end
end -- end TITHE.ChangePercent()


--displays the help screen, on /tithe ? and startup
function TITHE.ShowHelp()
  print (TITHE.GREEN.."Tithe ("..TITHE.VERSION..
        ")auto sends tithe to guild bank."..TITHE.NORMAL)
  print (TITHE.NORMAL.."usage:")
  print (TITHE.GREEN.."\t/tithe stats"..TITHE.NORMAL.." for statistics")
  print (TITHE.GREEN.."\t/tithe off"..TITHE.NORMAL.." (disables)")
  print (TITHE.GREEN.."\t/tithe on "..TITHE.NORMAL.." (enables)")
  print (TITHE.GREEN.."\t/tithe percent xx"..TITHE.NORMAL.." (sets the percent to tithe)")
  print (TITHE.GREEN.."\t/tithe baseline xx"..TITHE.NORMAL.." (if your credits below this amount it will not tithe)")
  print (TITHE.GREEN.."\t/tithe string 'msg: '"..TITHE.NORMAL.." (message to show up in the guild log)")
  print (TITHE.GREEN.."\t/tithe minimum xx"..TITHE.NORMAL.." (sets the miniumum amount to tithe)")
end -- end TITHE.ShowHelp


--register commands and events
RegisterUserCommand('tithe',TITHE.commands)

RegisterEvent(TITHE.handleevents,'CHAT_MSG_CONFIRMATION')


